//-----------------------------------------------------------------
// Programm:	MailToQuix
//          	Sendet Mailnachrichten ber ein Http-Cgi-Script an ein 
//	    	Quixempfnger
//          	Parameter:      <Quixnummer>		  Quix - Telefonnummer (7 Ziffern)
//				<Nachrichten pro Mail>    Nachrichten pro Mail 0..10
//				<Pfad der Filter-Datei>   Pfad der Filterdatei z.B. /etc
//	    	Datum: 09.10.97
//
//          	nderung am: 	02.11.97
//				Parameter fr Nachrichten pro Mail eingefgt/Filter bug entfernt
//		nderung am:	03.11.97
//				Parameter fr Filterdatei 
//		nderung am:	14.11.97
//				andere Klassenaufteilung
//		nderung am:	29.11.97
//				bertragung von Handy-Nachrichten (d1/d2)
//------------------------------------------------------------------

//Import -Vereinbarung
import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.Random;

//Klasse MailtoQuix mit Main-Funtion 
//-------------------------------------------------------------
class mailtoquix {

	//Konstanten
	private static final int MAX_NACH_PRO_MAIL = 0;    	//Gibt an wieviel Nachrichten default pro Mail bertragen 
								//werden sollen
								//0:      nur Absender und Subject
								//1..n: 1 Mail mit Absernder und 1..n Nachrichten mit Text	
	private static final String FILTER_DATEI = "/filter.dat";	//default Filterdatei
	private static String GERAET = "quix";				//default Gert

//============================================================================================================
	//Mainfuntion
	public static void main(String arg[]) {

		senden t = new senden();
		Integer intwert;
		String filterdatei;
		String geraet=GERAET;

		int max_nach_pro_mail = MAX_NACH_PRO_MAIL;
		if (arg.length == 4) {
			//Empfnger
			if (arg[0].regionMatches(true,0,"d1",0,2) || arg[0].regionMatches(true,0,"d2",0,2) || 
				arg[0].regionMatches(true,0,"quix",0,4)) {
				if (arg[0].regionMatches(true,0,"d1",0,2)) geraet = "D1"; 
				if (arg[0].regionMatches(true,0,"d2",0,2)) geraet = "D2"; 
				else geraet = GERAET; 
			} else {
				fehlermeldung(1);				
			};
			//Nachrichtenzahl
			try {
				intwert = new Integer(arg[2]);
				max_nach_pro_mail =  intwert.intValue();
			} catch (NumberFormatException e) {};
			if (max_nach_pro_mail >= 0 && max_nach_pro_mail <= 9) {
				//max_nach_pro_mail;
			} else {
				max_nach_pro_mail = MAX_NACH_PRO_MAIL;
			};
			//Filterdatei
			filterdatei = arg[3] + FILTER_DATEI;
			//Rufnummer
			if (arg[1].length()==7 && arg[2].length()==1) {
				if (t.meldungsenden(max_nach_pro_mail,geraet,arg[1],filterdatei)) {
					System.out.println("--->Bearbeitung beendet ... ");
				} else {
					System.out.println("--->Fehler!");
				};					
			} else {
				fehlermeldung(2);
			};
		} else {
			fehlermeldung(1);
		};
	};
//===========================================================================================================

	private static void fehlermeldung(int i) {

		switch(i) {
		case 1:
			System.out.println("Fehler: kein Empfnger oder keine Quixnummer oder Nachtichtenzahl fehlt!");
			System.out.println();
			System.out.println("Aufruf: java mailtoquix <QUIX|D1|D2> <Rufummer> <Nachrichtenzahl> <Filterdateipfad>");
			System.out.println("z.B.  : java mailtoquix      QUIX     1234567    0              /home/biber/mailtoquix/");
			System.out.println();
			System.out.println("(c) 1997  Markus Geisler, Michael Stterlin ");
			System.out.println("http://home.primus.baynet.de/mgeisler/quix.html");
			break;
		case 2: 
			System.out.println("Fehler:Die Quixnummer (7 Ziffern) oder die Nachrichtenzahl (max. 9) ist falsch!");
			System.out.println();
			System.out.println("Aufruf: java mailtoquix <QUIX|D1|D2> <Rufnummer> <Nachrichtenzahl> <Filterdateipfad>");
			System.out.println("z.B.  : java mailtoquix QUIX           1234567       0          /home/biber/mailtoquix/");
			System.out.println("Fehler: kein Empfnger oder keine Quixnummer oder Nachtichtenzahl fehlt!");
			System.out.println();
			System.out.println("(c) 1997 Markus Geisler, Michael Stterlin "); 
			System.out.println("http://home.primus.baynet.de/mgeisler/quix.html");
			break;
		};	
		System.exit(1);
			
	};

};



//Mail - Klasse
//Enthaelt die Maildaten und Funtionen zum einlesen der Mail von der 
//Standarteingabeaufforderung
//--------------------------------------------------------------
class mail {
	//Konstanten
	private static final String FILENAME = "tmp.";
	private static final int TEXTLANGE = 20000;

	//Variabeln
	private String subject, date, from, text;
	private int lsubject, ldate, lfrom, ltext;
	private int textln;
	private FileOutputStream outdatei;
	private FileInputStream indatei;
	private Random zufallszahl = new Random();
	public URLEncoder tomime;

	//Methoden
	public mail() {
		String zzahl;
		Integer izzahl = new Integer(zufallszahl.nextInt());
		zzahl=izzahl.toString();
		String tmp_name = FILENAME + zzahl;
		if(einlesen(tmp_name)) {
			if (eintext(tmp_name)==false) { tmp_datei_loeschen(tmp_name); System.exit(1);} 
			if (einfrom(tmp_name)==false) from = "--k. Absender--";
			if (eindate(tmp_name)==false) date = "--k. Datum--";
			if (einsubject(tmp_name)==false) subject = "--k. Betr.--";
		} else {
			if (!tmp_datei_loeschen(tmp_name)) {
				System.out.println("Fehler: TMP-Datei kann nicht gelscht werden!");
			};
			System.exit(1);
		};
		if (!tmp_datei_loeschen(tmp_name)) {
			System.out.println("Fehler: TMP-Datei kann nicht gelscht werden!");
			System.exit(1);
		};
	};

	public String aussubject() {
		return subject;
	};

	public String ausdate() {
		return date;
	};

	public String ausfrom() {
		return from;
	};
	
	public String austext() {
		return text;
	};
	

	public int laenge(char feld) {
		int wert=-1;
		switch (feld) {
		case 't': 
				if (ltext>=0) wert=ltext;
				break;  

		case 'f':
				if (lfrom>=0) wert=lfrom;
				break;  

		case 'd':
				if (ldate>=0) wert=ldate;
				break;  
	
		case 's':
				if (lsubject>=0) wert=lsubject;
				break;  

		default: 	wert=-1;
				break;
		};
		return wert;
	};
	
	private boolean tmp_datei_loeschen(String name) {
		File datei = new File(name);
		if (datei.exists()) {
			if (datei.delete()) { 
				return true;
			} else {
				return false;
			};
		}  else { 
			System.out.println("Fehler: Die TMP-Datei ist nicht vorhanden!");
			return false;
		};	
	};
	
	private boolean einlesen(String dateiname) {
		char da;
		char li;
		int zei,i;
		boolean leerz = false;
		try {
			outdatei = new FileOutputStream(dateiname);	
			outdatei.write('\n');		
		} catch (IOException e) { System.out.println("Fehler: TMP-Datei kann nicht erstellt werden!"); return false;};
		for (i=0;i<TEXTLANGE;i++) {
			try {
				zei = (System.in.read());
				li = (char) zei;
				if (zei == -1) { outdatei.write(''); break;};
				if (li == ' ' && leerz == true) {
				} else { 
					if (li== ' ') {
						leerz = true;
						outdatei.write(zei);
					} else {
						outdatei.write(zei);
						leerz = false;
					};
				}; 
			} catch (IOException e) {return false;};
		};
		try {
			outdatei.close();
		} catch (IOException e) { System.out.println("Fehler: TMP-Datei kann nicht erstellt werden!"); return false;};
		return true;
	};

	private boolean eintext(String dateiname) {
		char zeichen;
		boolean merker = false;
		int i, lauf;
		char artext[] = new char[TEXTLANGE];
		char cartext[] = new char[TEXTLANGE];
		boolean leerz = false;

		try {
			indatei = new FileInputStream(dateiname);			
		} catch (IOException e) { System.out.println("Fehler: Kann auf TMP-Datei nicht zugreifen!"); return false;};
		for (i=0;i<TEXTLANGE-1;i++) {
			try {
				zeichen = (char) (indatei.read());
				if (zeichen == '\n') {
					if ( merker == true) {
						break;
					} else { 
						merker = true;
					};
				} else { 
					merker = false;
				};
			} catch (IOException e) {System.out.println("Fehler: Kein Text gefunden!");return false;};
		};
		for (i=0;i<TEXTLANGE-1;i++) {
			try {
				artext[i] = (char) (indatei.read());
				if (artext[i] == '') { break;};
			} catch (IOException e) {return false;};
		};
		if (i==TEXTLANGE-1) {
			System.out.println("Fehler: Der eingelesene Text ist zu gro fuer die Bearbeitung!");
			return false;
		};
		artext[i] = '\n';
		text = new String(artext,0,i);
	
		//LF und CR durch " " ersetzen
		i=10;
		text = text.replace((char) i, ' ');
		i=13;
		text = text.replace((char) i, ' ');
		
		//Doppelte leerzeichen entfernen
		cartext = text.toCharArray();
		lauf = 0;
		for(i=0;i<text.length();i++) {
			if (cartext[i] == ' ' && leerz == true) {
			} else { if (cartext[i]== ' ') {
					leerz = true;
					artext[lauf] = cartext[i];
					lauf++;
				} else {
					artext[lauf] = cartext[i];
					lauf++;
					leerz = false;
				};
			};
		};
		text = new String(artext,0,lauf);
		text = text.trim();
		ltext = text.length();
		try {
			indatei.close();
		} catch (IOException e) { System.out.println("Fehler: TMP-Datei kann nicht erstellt werden!"); return false;};
		return true;
				
	};

	private boolean einfrom(String dateiname) {
		char zeichen;
		int zustand = 0;
		int i=0;
		char artext[] = new char[TEXTLANGE];
		boolean ok=false;
		try {
			indatei = new FileInputStream(dateiname);			
		} catch (IOException e) { System.out.println("Fehler: Kann auf TMP-Datei nicht zugreifen!"); return false;};
		for (i=0;i<TEXTLANGE-1;i++) {
			try {
				zeichen = (char) (indatei.read());
				if (zeichen=='\n') {	
					zustand = 0;
					for (i=0;i<6;i++) {
						zeichen = (char) (indatei.read());
						switch (zustand) {
						case 0: if (zeichen=='F') {zustand=1;}else{zustand=0;};break; 
						case 1: if (zeichen=='r') {zustand=2;}else{zustand=0;};break; 
						case 2: if (zeichen=='o') {zustand=3;}else{zustand=0;};break; 
						case 3: if (zeichen=='m') {zustand=4;}else{zustand=0;};break; 
						case 4: if (zeichen==':') {ok=true;break;} 
						};
					};
				};
			} catch (IOException e) {System.out.println("Fehler: Kein Text gefunden!");return false;};
			if (ok==true) break;
		};
		for (i=0;i<TEXTLANGE-1;i++) {
			try {
				artext[i] = (char) (indatei.read());
				if (artext[i] == '\n') { break;};
			} catch (IOException e) {return false;};
		};
		from = new String(artext,0,i);
		from = from.trim();
		lfrom = from.length();
		try {
			indatei.close();
		} catch (IOException e) { System.out.println("Fehler: TMP-Datei kann nicht erstellt werden!"); return false;};
		return true;
				
	};

	private boolean einsubject(String dateiname) {
		char zeichen;
		int zustand = 0;
		int i=0;
		char artext[] = new char[TEXTLANGE];
		boolean ok=false;
		try {
			indatei = new FileInputStream(dateiname);			
		} catch (IOException e) { System.out.println("Fehler: Kann auf TMP-Datei nicht zugreifen!"); return false;};
		for (i=0;i<TEXTLANGE;i++) {
			try {
				zeichen = (char) (indatei.read());
				if (zeichen=='\n') {	
					zustand = 0;
					for (i=0;i<9;i++) {
						zeichen = (char) (indatei.read());
						switch (zustand) {
						case 0: if (zeichen=='S') {zustand=1;}else{zustand=0;};break; 
						case 1: if (zeichen=='u') {zustand=2;}else{zustand=0;};break; 
						case 2: if (zeichen=='b') {zustand=3;}else{zustand=0;};break; 
						case 3: if (zeichen=='j') {zustand=4;}else{zustand=0;};break; 
						case 4: if (zeichen=='e') {zustand=5;}else{zustand=0;};break; 
						case 5: if (zeichen=='c') {zustand=6;}else{zustand=0;};break; 
						case 6: if (zeichen=='t') {zustand=7;}else{zustand=0;};break; 
						case 7: if (zeichen==':') {ok=true;break;} 
						};
					};
				};
			} catch (IOException e) {System.out.println("Fehler: Kein Text gefunden!");return false;};
			if (ok==true) break;
		};
		for (i=0;i<TEXTLANGE;i++) {
			try {
				artext[i] = (char) (indatei.read());
				if (artext[i] == '\n') { break;};
			} catch (IOException e) {return false;};
		};
		subject = new String(artext,0,i);
		subject = subject.trim();
		lsubject = subject.length();
		try {
			indatei.close();
		} catch (IOException e) { System.out.println("Fehler: TMP-Datei kann nicht erstellt werden!"); return false;};
		return true;
				
	};
	private boolean eindate(String dateiname) {
		char zeichen;
		int zustand = 0;
		int i=0;
		char artext[] = new char[TEXTLANGE];
		boolean ok=false;
		try {
			indatei = new FileInputStream(dateiname);			
		} catch (IOException e) { System.out.println("Fehler: Kann auf TMP-Datei nicht zugreifen!"); return false;};
		for (i=0;i<TEXTLANGE;i++) {
			try {
				zeichen = (char) (indatei.read());
				if (zeichen=='\n') {	
					zustand = 0;
					for (i=0;i<6;i++) {
						zeichen = (char) (indatei.read());
						switch (zustand) {
						case 0: if (zeichen=='D') {zustand=1;}else{zustand=0;};break; 
						case 1: if (zeichen=='a') {zustand=2;}else{zustand=0;};break; 
						case 2: if (zeichen=='t') {zustand=3;}else{zustand=0;};break; 
						case 3: if (zeichen=='e') {zustand=4;}else{zustand=0;};break; 
						case 4: if (zeichen==':') {ok=true;break;} 
						};
					};
				};
			} catch (IOException e) {System.out.println("Fehler: Kein Text gefunden!");return false;};
			if (ok==true) break;
		};
		for (i=0;i<TEXTLANGE;i++) {
			try {
				artext[i] = (char) (indatei.read());
				if (artext[i] == '\n') { break;};
			} catch (IOException e) {return false;};
		};
		date = new String(artext,0,i);
		date = date.trim();
		ldate = date.length();
		try {
			indatei.close();
		} catch (IOException e) { System.out.println("Fehler: TMP-Datei kann nicht erstellt werden!"); return false;};
		return true;
				
	};

};

//QuixSend-Klasse
//Schnittstelle zu o-Tel-o fr Quix-Nachrichten
//--------------------------------------------------------------
class quixsend {
	
	//Konstanten
	private static final int PORT = 80;
	private static final String SERVER = "www.o-tel-o.de";
//debug private static final String SERVER = "mother";

	//Variablen
	private Socket pop;
	private PrintStream popout;
	private DataInputStream popin; 
	private String sendetext = "--kein Text--";

	//Methoden
	public quixsend() {};

	public quixsend(String zeichenkette) {
		try {
			sendetext = zeichenkette;
			pop = new Socket(SERVER,PORT);
			popout = new PrintStream(pop.getOutputStream());
			popin = new DataInputStream(pop.getInputStream());
		} catch (IOException e) {System.out.println("Fehler: Kann die Netzverbindung nicht aufbauen!");};
	};
	
	//Subject-String fr den Quix erzeugen
	public String postcode(String nummer, String teil1, String teil2) {
		String HEADER  = "danke=%2FQUIX%2FDANKE.HTM&nr=";
		String BETWEEN = "&subject=";
		
		return (HEADER + nummer + BETWEEN + teil1 + teil2);
	};

	public boolean send() {
		try {
			popout.println("POST /cgi-bin/quixmail HTTP/1.0");
			popout.println("Referer: http://www.o-tel-o.de");
			popout.println("User-Agent: mailtoquix ((c)Michael Suetterlin)");
			popout.println("Host: www.o-tel-o.de");
			popout.println("Accept: text/html, text/plain, */*");
			popout.println("Content-type: application/x-www-form-urlencoded");
			popout.println("Content-length: " + sendetext.length());
			popout.println();
			popout.println(sendetext);
			popout.println();
			popout.println();
		} catch (NullPointerException e) {System.out.println("Fehler: Kein Zugriff auf das Netzwerk mglich!");return false;};
		System.out.println("->senden:  " + sendetext);
		return true;
	};		
	public boolean close() {
		try {
			pop.close();
		} catch (IOException e) {System.out.println("Fehler: Kann die Netzverbindung nicht beenden!"); return false;};
		return true;
	};
		
	private String lesen() {
		String wert = "--";
		return wert; 
	};	
	

};

//handySend-Klasse
//Schnittstelle zu ncs.tiss.com fr SMS-Nachrichten an Handy
//--------------------------------------------------------------
class handysend {
	
	//Konstanten
	private static final int PORT = 80;
	private static final String SERVER = "ncs.tiss.com";
//debug:private static final String SERVER = "mother";

	//Variablen
	private Socket pop;
	private PrintStream popout;
	private DataInputStream popin; 
	private String sendetext = "--kein Text--";

	//Methoden
	public handysend() {};

	public handysend(String zeichenkette) {
		try {
			sendetext = zeichenkette;
			pop = new Socket(SERVER,PORT);
			popout = new PrintStream(pop.getOutputStream());
			popin = new DataInputStream(pop.getInputStream());
		} catch (IOException e) {System.out.println("Fehler: Kann die Netzverbindung nicht aufbauen!");};
	};
	
	//
	public String postcode(String nummer, String netz, String teil1, String teil2) {
		String HEADER= "GET /cgi-bin/sendsms?serial=3334&error=http%3A%2F%2Fwww.nokia-shop.de%2Fsmser.htm&next=http%3A%2F%2Fwww.nokia-shop.de%2Fsmsok.htm&network=";
		String TARGET = "&target=";
		String BETWEEN= "&text=";
		String END= "&cemail=&validity=0 HTTP/1.0";

		return (HEADER + netz + TARGET+ nummer + BETWEEN + teil1 + teil2 + END);
	};

	public boolean send() {
		try {
			popout.println(sendetext);
			popout.println("Referer: http://WWW.NOKIA-SHOP.DE/sms.htm");
			popout.println("User-Agent: mailtoquix  ((c)1997 Michael Suetterlin)");
			popout.println("Host: ncs.tiss.com");
			popout.println("Accept: text/html, text/plain, */*");
			popout.println();
			popout.println();
			popout.println();
		} catch (NullPointerException e) {System.out.println("Fehler: Kein Zugriff auf das Netzwerk mglich!");return false;};
		System.out.println("->senden:  " + sendetext);
		return true;
	};		
	public boolean close() {
		try {
			pop.close();
		} catch (IOException e) {System.out.println("Fehler: Kann die Netzverbindung nicht beenden!"); return false;};
		return true;
	};
		
	private String lesen() {
		String wert = "--";
		return wert; 
	};	
	

};

//senden-Klasse
//Zusammenstellen der Nachrichten und versenden
//--------------------------------------------------------------
class senden {

	//Konstanten
	private static final int WAIT_MSEC = 20000;
	private static final int TEXTLANGE = 10000;
	private static final int MAX_TEXT_LANGE = 20000;
	private static final int MAX_MELD_LANGE_QUIX = 80;
	private static final int MAX_MELD_LANGE_HANDY = 135;
	private static final String LOCK_FILE_NAME = "mtq.lock";

	//Variablen
	private char da;
	private int i;
	private int MAX_MELD_LANGE = 80;
	private mail m1;
	//Methoden
	public senden() {
	};


	//Meldung versenden
	public boolean meldungsenden(int maxmeldungen, String geraet, String nummer,String filterdatei) {

		
		boolean gelockt = false;
		FileOutputStream lockfile;
		File lock = new File(LOCK_FILE_NAME);
		Thread thread = new Thread();				//Thread fuer sleep()
		URLEncoder translate;
		String body, from, strpuffer;
		m1 = new mail();
		String strlfrom = new String();		
		int geslaenge;
		int benmeld=1;
		int i=0, l=0;
		if (geraet.regionMatches(true,0,"D1",0,2)|| geraet.regionMatches(true,0,"D2",0,2)) {
			MAX_MELD_LANGE =MAX_MELD_LANGE_HANDY;
		};
		char puffer[] = new char[MAX_MELD_LANGE+10];
		char text[] = new char[MAX_TEXT_LANGE];
			
		//Filter
		//System.out.println(vergleichen("filter.dat",m1.austext()));
		if (!vergleichen(filterdatei,m1.ausfrom())) {

			//Lockfile exists? true wait	
			while (lock.exists()) {
				try { thread.sleep(2000); } catch (InterruptedException e) {};     //wait 2 sec.
			};

			//lockfile erstellen
			try{ lockfile = new FileOutputStream(LOCK_FILE_NAME);} catch (IOException e) {};

			//Absender der Mail versenden falls maxmeld > 0, sonst nur Subject mit absender senden
			if (maxmeldungen > 0) {
		
				//Lnge der Meldung 
				geslaenge = m1.laenge('t');
			
				//Wieviele Meldungen werden fr die Mail bentigt?
				if (geslaenge>MAX_MELD_LANGE) {
					benmeld = (geslaenge / MAX_MELD_LANGE);
					if ((geslaenge % MAX_MELD_LANGE) != 0) benmeld++;
				} else {
					benmeld = 1;
				};
				if (benmeld>=maxmeldungen) benmeld = maxmeldungen;
					
				//Body-Meldungen senden
				strpuffer = m1.austext();	//Text der Mail auslesen
				strpuffer = strpuffer.trim();
				text = strpuffer.toCharArray();
				for (i=benmeld-1;i>=0;i--) {
					for (l=0;l< MAX_MELD_LANGE;l++) {
						if (text.length>l+(MAX_MELD_LANGE*i)) {
							puffer[l] = text[l+(MAX_MELD_LANGE*i)];
						} else {
							puffer[l] = ' ';
						};
					};
					body = new String(puffer,0,MAX_MELD_LANGE);
					body = body.trim();

					//Nachricht senden
					if (!uebertragen(geraet,nummer,body,"")) {
						lock.delete(); 		//Lockfile loeschen  
						return false;
					};
				};	
			};

			//Warten
			try { thread.sleep(WAIT_MSEC); } catch (InterruptedException e) {};     //wait 2 sec.

			//From-Meldung senden
			//Mailsubject in den Puffer schreiben und Meldung versenden
			if (m1.ausfrom().length()<18) {
				strpuffer = m1.ausfrom() +" ->"+  m1.aussubject();	//From und Subject ausgeben
				strpuffer = strpuffer.substring(0,strpuffer.length());
			} else {
				strpuffer = m1.ausfrom().substring(0,17) + " ->" +  m1.aussubject();	//From und Subject ausgeben
				strpuffer = strpuffer.substring(0,strpuffer.length());
			};

			from = strpuffer.toString();
			from = from.trim();
			//Nachricht senden
			if (!uebertragen(geraet,nummer,from,"")) {
				lock.delete(); 		//Lockfile loeschen  
				return false;
			};						
			//Lockfile entfernen
			lock.delete();
		} else {
			System.out.println("->Mail von " + m1.ausfrom());	
			System.out.println("  nicht bertragen : siehe Datei 'filter.dat'");
		};//Filter
		return true;		
	};

	private boolean uebertragen(String geraet, String nummer, String var1, String var2) {

		Thread thread = new Thread();				//Thread fuer sleep()
		//Quix
		if (geraet.regionMatches(true,0,"Quix",0,4)) {
			quixsend qs = new quixsend();
			quixsend quix = new quixsend(qs.postcode(nummer,m1.tomime.encode(var1),m1.tomime.encode(var2)));
			if (quix.send()) {
				quix.close();
				try { thread.sleep(WAIT_MSEC); } catch (InterruptedException e) {};     //wait 2 sec.
			
			} else {
				return false;
			};
		};

		//D1
		if (geraet.regionMatches(true,0,"D1",0,2)) {
			handysend hs = new handysend();
			handysend handy = new handysend(hs.postcode(nummer, "D1", m1.tomime.encode(var1),m1.tomime.encode(var2)));
			if (handy.send()) {
				handy.close();
				try { thread.sleep(WAIT_MSEC); } catch (InterruptedException e) {};     //wait 2 sec.
			
			} else {
				return false;
			};
		};

		//D2
		if (geraet.regionMatches(true,0,"D2",0,2)) {
			handysend hs = new handysend();
			handysend handy = new handysend(hs.postcode(nummer, "D2", m1.tomime.encode(var1),m1.tomime.encode(var2)));
			if (handy.send()) {
				handy.close();
				try { thread.sleep(WAIT_MSEC); } catch (InterruptedException e) {};     //wait 2 sec.
			
			} else {
				return false;
			};
		};
		return true;
	};

	private boolean vergleichen(String filename ,String orgstring) {
		
		String vergstring;
		FileInputStream file;
		File filetest;
		char puffer[];
		char pufferorg[] = new char [MAX_TEXT_LANGE];
		boolean ok=false;
		boolean weiter;
		int i,lorgstring,lvergstring,lauf,t;
		int l=-1;
		int merkt=0;

		//File vorhanden, wenn ja dann:String aus Datei einlesen
		filetest = new File(filename);
		if (filetest.exists()) {
			try { file = new FileInputStream(filename);} catch (IOException e) {System.out.println("Fehler: Beim lesen aus der Datei 'filter.dat'");return false;};	 
		} else { 
			return false;
		};
		t=0;		
		
		while (true) {
		try {
		puffer = new char[4000];
		for (t=merkt;t<4000;t++) {
			if (t==888) return false;
			try { puffer[t] = (char)file.read();} catch (IOException e) {return false;};		
			if (puffer[t] == ';') {merkt=t;break;};
			
		};
		} catch (ArrayIndexOutOfBoundsException e) {return false;};	

		vergstring = new String(puffer,0,t);
		vergstring = vergstring.trim();
		
		if (vergstring.length() > 0) {
			//Vergleich mit OrginalString
			orgstring = orgstring.trim();
			lorgstring = orgstring.length();
			lvergstring = vergstring.length();
			puffer = vergstring.toCharArray();
			pufferorg = orgstring.toCharArray();
	
			//System.out.println(vergstring);	
			//System.out.println(orgstring);	
			if (lorgstring>lvergstring) {
				for (i=0;i<lorgstring-lvergstring;i++) {
					weiter = false;
					if (pufferorg[i]==puffer[0]&& lvergstring>=1) {	
						weiter=true;
						lauf=i;
						for(l=1;l<lvergstring && weiter==true;l++) {
							if (pufferorg[++lauf]==puffer[l]) weiter=true; else weiter=false;
						};
					};
					if (weiter==true && l == lvergstring) {return true;};
				};
			} else {
				if (orgstring.equals(vergstring)) return true;
			};
		};
		};//while	
	};	
};


